Imports System.Drawing.Drawing2D

Module TransformationStuff
    ' Map the world coordinates wxmin, wymin, wxmax, wymax to 
    ' the device coordinates dxmin, dymin, dxmax, dymax.
    Public Sub MapGraphicsWindow(ByVal gr As Graphics, _
     ByVal wxmin As Single, ByVal wymin As Single, ByVal wxmax As Single, ByVal wymax As Single, _
     ByVal dxmin As Single, ByVal dymin As Single, ByVal dxmax As Single, ByVal dymax As Single)
        ' Clear any current transformation.
        gr.ResetTransform()

        ' Translate the world coordinate center to the origin.
        gr.TranslateTransform( _
            -(wxmax + wxmin) / 2, _
            -(wymax + wymin) / 2, _
            MatrixOrder.Append)

        ' Scale.
        Dim sx As Single = CSng((dxmax - dxmin) / (wxmax - wxmin))
        Dim sy As Single = CSng((dymax - dymin) / (wymax - wymin))
        gr.ScaleTransform(sx, sy, MatrixOrder.Append)

        ' Translate the origin to the device coordinate center.
        gr.TranslateTransform( _
            (dxmax + dxmin) / 2, _
            (dymax + dymin) / 2, _
            MatrixOrder.Append)
    End Sub
End Module
